"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const constants_1 = require("./constants");
const formatRequestName = (requestName, { payload, meta }) => {
    const actionPayloadMeta = {};
    if (typeof payload === 'object') {
        Object.assign(actionPayloadMeta, payload);
    }
    if (typeof meta === 'object') {
        Object.assign(actionPayloadMeta, meta);
    }
    if (actionPayloadMeta.actionId) {
        return `${requestName}_${actionPayloadMeta.actionId.toString().toUpperCase()}`;
    }
    return requestName;
};
function reducer(state = {}, action) {
    const { type, payload, meta } = action;
    const matches = /(.*)\/(.*)_(START|SUCCESS|FAILURE|CANCEL|CLEAR)/.exec(type);
    if (!matches)
        return state;
    const [, , requestName, requestState] = matches;
    const formattedRequestName = formatRequestName(requestName, action);
    if (requestState === constants_1.CLEAR) {
        const _a = state, _b = formattedRequestName, _ = _a[_b], rest = __rest(_a, [typeof _b === "symbol" ? _b : _b + ""]);
        return rest;
    }
    const resultStatus = [constants_1.SUCCESS, constants_1.FAILURE];
    if (state[formattedRequestName]
        && [constants_1.CANCEL, constants_1.FAILURE].includes(state[formattedRequestName][0])
        && requestState !== constants_1.START) {
        return state;
    }
    if (requestState === constants_1.START) {
        if (meta === null || meta === void 0 ? void 0 : meta.store) {
            const current = state[formattedRequestName];
            return Object.assign(Object.assign({}, state), { [formattedRequestName]: current ? [constants_1.START, current[1]] : [constants_1.START, constants_1.NEVER] });
        }
        return Object.assign(Object.assign({}, state), { [formattedRequestName]: [constants_1.START] });
    }
    if (state[formattedRequestName] && [...resultStatus, constants_1.CANCEL].includes(requestState)) {
        const storingData = [requestState];
        if (meta === null || meta === void 0 ? void 0 : meta.store) {
            storingData.push(resultStatus.includes(requestState) ? payload : undefined);
        }
        return Object.assign(Object.assign({}, state), { [formattedRequestName]: storingData });
    }
    return state;
}
exports.default = reducer;
