import { Action, ActionFunctionAny, ActionMeta } from 'redux-actions';
export declare type AsyncActionState = 'START' | 'SUCCESS' | 'FAILURE' | 'CANCEL';
export declare type BaseAction = Action<any> | ActionMeta<any, any>;
export declare type Context = {
    [label: string]: any;
};
export declare type AsyncActionControlOptions = {
    initialValue: any;
    context: Context;
};
export declare type AsyncBaseActionControl = {
    start: ActionFunctionAny<BaseAction>;
    success: ActionFunctionAny<BaseAction>;
    failure: ActionFunctionAny<BaseAction>;
    cancel: ActionFunctionAny<BaseAction>;
    clear: ActionFunctionAny<BaseAction>;
};
export declare type AsyncActionReducerData = [AsyncActionState, any] | [AsyncActionState];
export declare type AsyncActionReducer = {
    [actionName: string]: AsyncActionReducerData;
};
export declare type Selector = (state: any) => any;
export declare type AwaitControlInitializer = {
    keyReducer?: string;
    extractState?: (s: any) => any;
    baseContext?: Context;
};
export declare type ResultSelector<T = any> = (actionId?: string | number) => T;
export declare type AwaitControlHook = {
    start: (payload?: any, meta?: any) => BaseAction;
    success: (payload?: any, meta?: any) => BaseAction;
    cancel: (payload?: any, meta?: any) => BaseAction;
    failure: (payload?: any, meta?: any) => BaseAction;
    clear: (payload?: any, meta?: any) => BaseAction;
    isRunning: (actionId?: string | number) => boolean;
    wasCancelled: (actionId?: string | number) => boolean;
    hasFailure: (actionId?: string | number) => boolean;
    isSuccessful: (actionId?: string | number) => boolean;
    result: ResultSelector;
};
