"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.get = exports.camelCase = void 0;
const camelCase = (word) => word.toLowerCase().replace(/[^a-zA-Z0-9]+(.)/g, (m, chr) => chr.toUpperCase());
exports.camelCase = camelCase;
const get = (obj, path) => {
    if (!path)
        return obj;
    const keys = path.split('.');
    return keys.reduce((value, key) => {
        if (!value)
            return undefined;
        return value[key];
    }, obj);
};
exports.get = get;
